/// <reference types="node" />
import { Device } from './model';
export declare function findDeviceList(deviceOpts: Device['deviceOpts'], apib: Device['apib']): Device[];
export declare function findDevice(port: Device['deviceOpts']['port'], deviceOpts: Device['deviceOpts'], apib: Device['apib']): Device;
/** Sampling fingerprint once, return base64 */
export declare function readOnce(device: Device, bufLen?: number): Buffer;
/** Sampling fingerprint 3times, return base64 */
export declare function readThrice(device: Device, bufLen?: number): Buffer;
export declare function compareFP(device: Device, fp1: Buffer, fp2: Buffer): Promise<boolean>;
