import { Device, Options, SampleMode } from './model';
export declare function init(options: Options): Promise<Device[]>;
/**
 * Sample fingprint
 *
 * mode (default: strict):
 *  - simple: read once
 *  - strict: read 3 times
 */
export declare function sampleFP(device: Device, mode?: SampleMode): Promise<string>;
export declare function verifyFP(device: Device, fp: string): Promise<boolean>;
